<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { privacyDataHelper } from '../../services/privacy/privacy.service';
import { Disclaimer } from '@/components/gartner/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  components: {
    Disclaimer,
  },
  async asyncData({ $content, error, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;

      if (locale) {
        const content = await $content(locale, 'privacy').fetch();
        return { doc: content[0] };
      }

      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        locale: 'en-US',
        'fields.slug': 'privacy',
        include: 3,
      });

      const { pageContent } = response.items[0].fields;

      const doc = privacyDataHelper(pageContent);
      const metadata = response.items[0].fields.seoMetadata[0].fields;
      return { doc, metadata };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  nuxtI18n: {
    locales: ['fr-fr', 'de-de', 'ja-jp', 'en-us'],
  },
  head(): MetaInfo {
    if (this.metadata) {
      return getPageMetadata(
        (this as any).metadata,
        this.$route.path,
        this.$nuxtI18nHead({ addSeoAttributes: true }),
      );
    }
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div class="privacy">
    <SlpContainer class="slp-mb-96">
      <section>
        <SlpTypography
          variant="heading1-bold"
          tag="h1"
          class="slp-mt-64 slp-mb-24"
        >
          {{ doc.hero_title }}
        </SlpTypography>
        <SlpHorizontalRule />
        <SlpTypography class="last-updated slp-mt-16" tag="p" variant="body2">
          {{ doc.last_updated }}
        </SlpTypography>
        <SlpTypography tag="div" variant="body1" class="slp-mt-32">
          <span class="hero-copy" v-html="$md.render(doc.copy)"> </span>
        </SlpTypography>
      </section>
      <div class="hero-gradient slp-mt-64 slp-mb-24"></div>

      <SlpSideNavigation :data="doc.side_menu">
        <section
          v-for="section in doc.sections"
          :id="section.id"
          :key="section.header"
          class="body-copy"
        >
          <SlpTypography tag="h2" variant="heading4-bold" class="slp-my-32">
            {{ section.header }}
          </SlpTypography>
          <SlpTypography tag="div" variant="body2">
            <span v-html="$md.render(section.text)"> </span>
          </SlpTypography>
        </section>
      </SlpSideNavigation>
    </SlpContainer>
    <Disclaimer v-if="doc.disclaimer" v-bind="doc.disclaimer" />
  </div>
</template>

<style lang="scss" scoped>
.privacy > * {
  word-wrap: break-word;
}
.last-updated {
  font-style: italic;
}

.hero-gradient {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
}

.hero-copy:deep,
.body-copy:deep {
  ul {
    list-style-type: disc;
    list-style-position: inside;
    padding-left: 2.3em;
  }

  li {
    margin-bottom: $spacing-8;
  }

  p,
  ul,
  h2,
  h3 {
    margin-bottom: $spacing-16;
  }

  li > p {
    display: inline;
  }

  h3 {
    font-size: $text-heading-5;
    line-height: $line-height-heading-5;
    font-weight: $font-weight-bold;
    margin: $spacing-32 0 $spacing-24 0;
  }
}
</style>
